/***************************************************************************
                          kwiconlistbox.cpp  -  description
                             -------------------
    begin                : ??? Dec 05 2007
    copyright            : (C) 2007 by Baryshev Dmitry
    email                : ksquirrel.iv@gmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "kwiconlistbox.h"
#include "kwiconlistitem.h"

KWIconListBox::KWIconListBox(QWidget *parent, const char *name, WFlags f) : KListBox(parent, name, f),
    mHeightValid(false), mWidthValid(false)
{
    setHScrollBarMode(QScrollView::AlwaysOff);
}

void KWIconListBox::updateWidth()
{
    if(!mWidthValid)
    {
        int maxWidth = 10, w;

        for(QListBoxItem *i = item(0); i != 0; i = i->next())
        {
            w = ((KWIconListItem *)i)->width(this);
            maxWidth = QMAX(w, maxWidth);
        }

        for(QListBoxItem *i = item(0); i != 0; i = i->next())
            ((KWIconListItem *)i)->expandMinimumWidth(maxWidth + 30);

        if(verticalScrollBar()->isVisible())
            maxWidth += verticalScrollBar()->sizeHint().width();

        setFixedWidth(maxWidth + frameWidth()*2 + 30);
        mWidthValid = true;
    }
}

void KWIconListBox::invalidateHeight()
{
    mHeightValid = false;
}

void KWIconListBox::invalidateWidth()
{
    mWidthValid = false;
}

void KWIconListBox::updateAndInstall(QObject *o)
{
    invalidateHeight();
    invalidateWidth();
    updateWidth();

    QFont listFont(font());

    listFont.setBold(true);
    setFont(listFont);
    verticalScrollBar()->installEventFilter(o);
    setCurrentItem(0);
    setSelected(0, true);
}
