/***************************************************************************
                          kwlabel.h  -  description
                             -------------------
    begin                : ??? Dec 5 2007
    copyright            : (C) 2007 by Krasu
    email                : ksquirrel.iv@gmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KWLABEL_H
#define KWLABEL_H

#include <qlabel.h>
#include <qcolor.h>
#include <qvaluevector.h>

#include "entry.h"
#include "kickertip.h"

class QTimer;

class KWLabel : public KickerTip
{
    Q_OBJECT

    public: 
        enum MessageType { Added, Deleted };

        KWLabel(QWidget *parent = 0);
    	~KWLabel();

        bool incomingSett() const;
        bool outgoingSett() const;

        void addText(const Entry &e, MessageType);
        void setXY(int x, int y);

        void rereadSettings();

    private:
        bool updateText();

    private slots:
        void slotTimer();

    private:
        int m_x, m_y;
        QTimer *timer;
        QString bgcolor_con, bgcolor_discon;
        int delay;
        bool incoming, outgoing;

        struct LabelEntry
        {
            Entry e;
            MessageType message;
        };

        typedef QValueVector<LabelEntry> Labels;

        Labels labels;
};

inline
void KWLabel::setXY(int x, int y)
{
    m_x = x;
    m_y = y;
}

inline
bool KWLabel::incomingSett() const
{
    return incoming;
}

inline
bool KWLabel::outgoingSett() const
{
    return outgoing;
}

#endif
