/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/

class KWListViewItem : public KListViewItem
{
public:
    KWListViewItem(QListView *parent, QListViewItem *after, int id, const QString &label1, const QString &label2, const QString &label3, const QString &label4, const QString &label5, const QString &label6)
	: KListViewItem(parent, after, label1, label2, label3, label4, label5, label6), m_id(id)
    {}

    ~KWListViewItem()
    {}

    unsigned long id() const
    {
	return m_id;
    }

private:
    unsigned long m_id;
};

void KWMonitor::init()
{
    connect(pushClose, SIGNAL(clicked()), this, SLOT(hide()));
}

void KWMonitor::slotAdded(const Entry &e)
{
    new KWListViewItem(list, list->lastItem(), e.id, e.protocol, e.service, e.userString, e.app, e.addressLocal+':'+QString::number(e.addressLocalPort), e.addressRemote+':'+QString::number(e.addressRemotePort));
    labelTotal->setText(QString::number(list->childCount()));
}

void KWMonitor::slotDeleted(const Entry &e)
{
    QListViewItemIterator it(list);
    KWListViewItem *kwi;

    while((kwi = static_cast<KWListViewItem *>(it.current())))
    {
        if(kwi->id() == e.id)
        {
	    delete kwi;
	    labelTotal->setText(QString::number(list->childCount()));
	    return;
        }

	++it;
    }
}

void KWMonitor::closeEvent(QCloseEvent *e)
{
    hide();
    e->ignore();
}
